<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="~../reggie-2.js,~demux_confirm.js" 
	styles="path.css,~../css/reggie-2.css"
	>
<style>

#fc-info-table
{
	border-collapse: collapse;
	background-color: #FFFFFF;
	border-width: 1px;
}

#fc-info-table td, #fc-info-table th
{
	padding: 1px 4px 1px 4px;
	text-align: center;
	border-left-width: 1px;
	border-left-style: dotted;
	border-right-width: 1px;
	border-right-style: dotted;
}

thead
{
	border-bottom-width: 1px;
}

tr.highlight
{
	border-top-width: 1px;
	border-top-style: dotted;
}


#mergedSequencesTable
{
	width: 100%; 
	border-collapse: collapse;
}

#mergedSequencesTable thead
{
	border-top-width: 1px;
}

#mergedSequencesTable td
{
	text-align: center;
	min-width: 4em;
}

#mergedSequencesTable tbody td
{
	padding-top: 1px;
	padding-bottom: 1px;
}

#mergedSequencesTable .warning-col
{
	max-width: 20px;
	min-width: 0;
}


#mergedSequencesTable .italic
{
	font-style: italic;
}

.comment input
{
	width: 95%;
	min-width: 20em;
}

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Confirm demux and merge ended" 
		/></p:path>

	<div class="content">
	<form name="reggie" id="wizard" class="wizard">
	
	<div class="step auto-hide" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select demux job</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Demux jobs</td>
				<td class="input">
					<select class="required" name="seqRuns" id="demuxJobs"></select>
				</td>
				<td class="status" id="demuxJobs.status"></td>
				<td class="help">
					<span id="demuxJobs.message" class="message"></span>
					Select a demux job. The list contains all demux jobs that has
					ended but has not been confirmed (determined by the absense 
					of AnalysisResult annotation on demuxed sequences items).
				</td>
			</tr>
			<tbody class="info-section">
			<tr>
				<td class="prompt">Start date</td>
				<td class="info" id="startDate" colspan="3"></td>

			</tr>
			<tr>
				<td class="prompt">End date</td>
				<td class="info" id="endDate" colspan="3"></td>

			</tr>
			<tr>
				<td class="prompt">Status</td>
				<td class="info" id="jobStatus" colspan="3"></td>
			</tr>
			<tr>
				<td class="prompt">Flow cells</td>
				<td class="info" id="flowCellsInDemux" colspan="3"></td>
			</tr>
			<tr>
				<td class="prompt">Pools</td>
				<td class="info" id="pools" colspan="3"></td>
			</tr>
			<tr>
				<td class="prompt">LibPlates</td>
				<td class="info" id="libPlates" colspan="3"></td>
			</tr>
			<tr>
				<td class="prompt">Comments</td>
				<td class="info" id="comments" colspan="3"></td>
			</tr>
			<tr>
				<td class="prompt">Warnings</td>
				<td class="info" id="warnings" colspan="3"></td>
			</tr>
			<tr id="skippedTilesRow" style="display: none;">
				<td class="prompt">Skipped tiles</td>
				<td class="info" id="skippedTiles" colspan="3"></td>
			</tr>
			</tbody>
			</table>
			
		</div>
	</div>
	
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title" id="step-2-title">Demux job</div>
		<div class="step-content">
			<table class="step-form">
			<tr>
				<td class="prompt">Outcome</td>
				<td class="input">
					<label><input type="radio" name="outcome" id="outcomeSuccessful" 
						checked>Success</label> - continue with alignment<br>
					<label><input type="radio" name="outcome" id="outcomeFailed" 
						>Failure</label> - no alignment<br>
					<img src="../images/joinbottom.gif"><label><input type="checkbox" name="flagPools" id="flagPools" disabled>Flag pools for re-clustering</label><br>
					<label id="delete-items" style="padding-left: 18px;"
						><input type="checkbox" name="deleteItemsCreatedByFailedJob" id="deleteItemsCreatedByFailedJob" disabled
							>Delete items created by failed job</label><br>
					<label id="demux-again" style="padding-left: 18px;"
						><input type="checkbox" name="demuxAgain" id="demuxAgain" disabled
							>Re-try demuxing</label>
				</td>
				<td class="status" id="outcome.status"></td>
				<td class="help">
					<span id="outcome.message" class="message"></span>
					Select the <b>Success</b> option if the demux was successful 
					and it is possible to continue with masking and alignment of 
					the sequences. Select the <b>Failure</b> option if it not 
					possible to continue. Existing pooled libraries can optionally
					be flagged for re-clustering and re-sequencing.<br>
					¹ CA_Size* is the average size measued by Caliper with adapter size removed (-118).<br>
					² Values are calculated based on Bowtie alignment of a subset of the sequences.
				</td>
			</tr>
			</table>

			<div id="mergedSequences"></div>
		</div>
	</div>
		
	<div id="wizard-status"></div>

	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>