<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	int libPlateId = Values.getInt(request.getParameter("bioplate"));
	String poolSchema = request.getParameter("poolSchema");
	String barcodeVariant = request.getParameter("barcodeVariant");
	
	BioPlate plate = BioPlate.getById(dc, libPlateId);
	int columns = plate.getColumns();
	int rows = plate.getRows();
	String view = Values.getString(request.getParameter("view"), "list");
	String title = "Lab protocol for " + HTML.encodeTags(plate.getName()) + " - " + (view.equals("list") ? "list" : "table");
%>
<base:page id="protocol" type="iframe" favicon="<%=home+"/images/libprep.png"%>" title="<%=title%>" noskin="true">
<base:head
	scripts="~../reggie-2.js,~pools.js,~plate.js,~libprep_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css,~../css/plate.css"
	>
	<style>
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: top;
		height: 1.25em;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 2px;
	}
	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}
	
	#listview
	{
		width: 100%;
		font-size: 85%;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	#listview tr.evencol
	{
		background-color: #F0F0F0;
	}
	
	#listview thead
	{
		border: 1px solid #000000;
		background-color: #F0F0F0;
	}
	
	#listview tbody
	{
		page-break-inside: avoid;
		border-top: 1px solid #000000;
		border-bottom: 1px solid #000000;
	}
	
	#listview th
	{
		border-left: 1px solid #000000;
	}
	
	#listview td
	{
		border-left: 1px solid #000000;
		border-top: 1px dotted #666666;
		vertical-align: middle;
	}
	
	#listview .col-num
	{
		width: 1.75em;
		text-align: center;
		font-size: 125%;
		font-weight: bold;
		vertical-align: top;
	}
	
	#listview .lib
	{
		width: 15em;
		text-align: center;
	}
	
	#listview .empty .lib
	{
		font-style: italic;
		color: #666666;
		text-align: center;
	}
	
	#listview .workplate, #listview .barcode
	{
		width: 7em;
		text-align: center;
	}
	#listview .remarks
	{
		vertical-align: top;
		padding-left: 0.25em;
	}
	
	/* Divide the 12 wells across the full page */
	#plateview .well
	{
		width: 8.2%;
		max-width: 8.2%;
		min-width: 8.2%;
		padding: 4px;
	}
	
	#plateview .well:hover
	{
		padding: 3px;
	}
		
	#plateview .rowheader
	{
		width: 2em;
	}
	
	#plateview .lib
	{
		font-weight: bold;
		margin-bottom: 0.25em;
	}
	#plateview .remarks
	{
		color: #C80000;
		font-style: italic;
	}
	
	#plateview .well.primary.empty
	{
		background-color: #FFFFFF;
	}
	
	</style>
</base:head>
<base:body>
	<div class="paper <%=view.equals("list") ? "" : "landscape"%>">

	<form name="reggie" id="wizard">
	
	<div id="page-data" class="datacontainer"
		data-view="<%=view%>"
		data-libplate="<%=libPlateId%>"
		data-schema="<%=poolSchema%>"
		data-barcode-variant="<%=barcodeVariant%>"
		data-rows="<%=rows%>"
		data-columns="<%=columns%>"
	></div>

	<div id="wizard-status"></div>

	<div id="all-protocol" style="display: none;">

	<div id="print-instructions" class="noprint fullwidth">
		<base:button id="print-button" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<span id="printNote">
		<b>Note!</b> 
		<%
		if (view.equals("list"))
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. To fit everything on a single page, scale down to <i>60-70%</i>.
			<%
		}
		else
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>landscape</i>. The recommended scale is <i>100%</i>.
			<%
		}
		%>
		</span>
		<br clear="all">
	</div>

	
	<h1>Lab protocol for library preparation <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<table style="width: 100%;" class="protocolheader">
	<tr style="border-bottom: 1px solid #000000;">
		<th style="width: 15%;">Work plate</th>
		<td style="width: 30%; border-right: 1px solid #000000;"><%=HTML.encodeTags(plate.getName())%></td>
		<th style="width: 15%;">LibPrep</th>
		<th style="width: 20%;">Date</th>
		<th style="width: 20%;">Operator</th>
	</tr>
	<tr>
		<td rowspan="2" colspan="2" style="width: 50%; border-right: 1px solid #000000;"><%=HTML.niceFormat(plate.getDescription()) %></td>
		<td style="border-right: 1px solid #000000;">Amplification</td>
		<td style="border-right: 1px solid #000000;"></td>
		<td></td>
	</tr>
	<tr style="border-top: 1px solid #CCCCCC;">
		<td style="border-right: 1px solid #000000;">Cleanup</td>
		<td style="border-right: 1px solid #000000;"></td>
		<td></td>
	</tr>
	</table>

	<%
	if (view.equals("list"))
	{
		%>
		<div id="listviewcontainer">
		<table style="width: 100%;" id="listview">
		<thead>
			<tr class="toprow">
				<th></th>
				<th class="lib"></th>
				<th class="workplate">Work</th>
				<th class="barcode">TruSeq</th>
				<th></th>
			</tr>
			<tr>
				<th></th>
				<th class="lib">Library</th>
				<th class="workplate">plate</th>
				<th class="barcode">index</th>
				<th>Remarks</th>
			</tr>
		</thead>
		<%
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		for (int c = 0; c < columns; ++c)
		{
			String rowClass = c % 2 == 0 ? "evencol" : "oddcol";
			%>
			<tbody>
			<%
			for (int r = 0; r < rows; ++r)
			{
				String idSuffix = c + "." + r;
				%>
				<tr class="<%=rowClass%> empty" id="row.<%=idSuffix%>">
					<%
					if (r == 0)
					{
						%>
						<td id="col.<%=c%>" class="col-num" rowspan="<%=rows%>"><%=c+1%></td>
						<%
					}
					%>
					<td class="lib" id="lib.<%=idSuffix%>">empty</td>
					<td class="workplate"><%=rowF.format(r)+colF.format(c)%></td>
					<td class="barcode" id="barcode.<%=idSuffix%>"></td>
					<td class="remarks" id="remarks.<%=idSuffix%>"></td>
				</tr>
				<%
			}
			%>
			</tbody>
			<%
		}
		%>
		</table>
		</div>
		<%
	}
	else
	{
		%>
		<div id="plateviewcontainer">
		<table class="plate" style="margin: 0em 0 0 0; width: 100%;" id="plateview">
		<%
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		%>
		<tr class="header">
			<th></th>
			<%
			for (int c = 0; c < columns; ++c)
			{
				%>
				<th id="col.<%=c%>"><%=colF.format(c)%></th>
				<%
			}
			%>
		</tr>
		<tbody>
		<%
		for (int r = 0; r < rows; ++r)
		{
			String row = rowF.format(r);
			%>
			<tr class="row-<%=r%>">
				<th id="row.<%=r%>" class="rowheader"><%=row%></th>
				<%
				for (int c = 0; c < columns; ++c)
				{
					%>
					<td class="well col-<%=c%>" id="well.<%=r%>.<%=c%>"></td>
					<%
				}
				%>
			</tr>
			<%
		}
		%>
		</tbody>
		<tr id="pool-row">
			<th colspan="13">&nbsp;</th>
		</tr>
		</table>
		</div>
		<%
	}
	%>
</div>
</form>
</div>
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>