var FlaggedRna = function()
{
	var flaggedrna = {};
	var debug = 0;

	// Page initialization
	flaggedrna.initPage = function()
	{
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnUseSelected', flaggedrna.useSelected);
		Buttons.addClickHandler('btnUnflagSelected', flaggedrna.unflagSelected);
		
		var flagged = window.opener.Rna.getFlagged();
		var frm = document.forms['flaggedRna'];
		for (var i = 0; i < flagged.length; i++)
		{
			var rna = flagged[i];
			var name = Strings.encodeTags(rna.name);
			var link = '<img class="link case-summary" data-name="'+name+'" src="../images/case_summary.png">';
			Doc.element('rna.'+i).innerHTML = name+link;
			if (rna.bioWell)
			{
				var well = rna.bioWell;
				Doc.element('location.'+i).innerHTML = Strings.encodeTags(well.bioPlate.name +' ['+Reggie.wellToAlpha(well.row)+(well.column+1)+']');
			}
			var qs = rna.rqs || rna.rin;
			Doc.element('remainingQuantity.'+i).innerHTML = Numbers.formatNumber(rna.remainingQuantity, 2);
			Doc.element('qualityScore.'+i).innerHTML = Numbers.formatNumber(qs, qs < -10 ? 0 : 1);
			Doc.element('comment.'+i).innerHTML = Strings.encodeTags(rna.comment || '');
			Doc.element('flag.'+i).innerHTML = Strings.encodeTags(rna.flag);
			if (rna.flag == 'NotEnoughRemainingQuantity')
			{
				Doc.addClass('remainingQuantity.'+i, 'bold');
			}
			else if (rna.flag == 'LowQualityScore')
			{
				Doc.addClass('qualityScore.'+i, 'bold');
			}
			else
			{
				Doc.addClass('comment.'+i, 'bold');
			}
			frm['use.'+i].rna = rna;
		}

		var cs = document.getElementsByClassName('case-summary');
		for (var i = 0; i < cs.length; i++)
		{
			Events.addEventHandler(cs[i], 'click', flaggedrna.showCaseSummary);
		}
	
	}

	flaggedrna.showCaseSummary = function(event)
	{
		var name = Data.get(event.currentTarget, 'name');
		var caseName = name.substring(0, 7);
		var url = '../reports/case_summary.jsp?ID='+App.getSessionId();
		url += '&caseName='+encodeURIComponent(caseName);
		url += '&pageType=popup';
		Dialogs.openPopup(url, 'CaseSummary'+caseName, 1000, 700);
	}
	
	flaggedrna.useSelected = function()
	{
		var frm = document.forms['flaggedRna'];
		var i = 0;
		var selected = [];
		while (frm['use.'+i])
		{
			if (frm['use.'+i].checked)
			{
				var rna = frm['use.'+i].rna;
				selected[selected.length] = {'id': rna.id, 'name': rna.name };
			}
			i++;
		}
		
		var remaining = selected.length-1;
		for (var i = 0; i < selected.length; i++)
		{
			var s = selected[i];
			s.remaining = remaining--;
			Events.sendCustomEvent(window.opener.Doc.element('plate'), 'base-selected', s);
		}
		
		window.close();
	}
	
	flaggedrna.unflagSelected = function()
	{
		var frm = document.forms['flaggedRna'];
		var i = 0;
		while (frm['use.'+i])
		{
			if (frm['use.'+i].checked)
			{
				var rna = frm['use.'+i].rna;
				window.opener.Rna.unflag(window.opener.Rna.createByName(rna.name));
			}
			i++;
		}
		window.opener.SelectRna.updateNumFlaggedRna();
		window.close();
	}



	return flaggedrna;
}();

Doc.onLoad(FlaggedRna.initPage);

